"""# readMRCfile readMRCfile (fname);a: data;b: the first 224 byte data of the head 1024 bytes data, stored as 56 'long' type data; c: the remaining 800
# bytes data, stored as 'char' type data;

#b= struct.unpack('llllllllllfffffflllfffhhlhhhhhhhhhhhhhhhhhhlllllllhhhhhhfffffffffccccccccfl', infile[start:stop])
#b data read
#b(1:4)=[nx ny nz type];
#b(5:10)=fread(fid,6,'long'); % NXSTART/NYSTART/NZSTART Number of first COLUMN/ROWS/SECTIONS in map (Default = 0) & MX/MY/MZ Number of intervals along X/Y/Z 
#b(11:16)=fread(fid,6,'float'); % XLEN/YLEN/ZLEN Cell Dimensions (Angstroms) & ALPHA/BETA/GAMMA Cell Angles (Degrees) 
#b(17:19)=fread(fid,3,'long'); % MAPC/MAPR/MAPS Which axis corresponds to Columns/Rows/Sections (1,2,3 for X,Y,Z) 
#b(20:22)=fread(fid,3,'float'); % AMIN/AMAX/AMEAN Minimum/Maximum/Mean density value 
#b(23)=fread(fid,1,'short');  % ISPG Space group number (0 for images) 
#b(24)=fread(fid,1,'short'); % NSYMBT  Number of bytes used for storing symmetry operators 
#b(25)=fread(fid,1,'long'); % NEXT Number of bytes in extended header 
#b(26)=fread(fid,1,'short'); % CREATID  Creator ID 
#b(27:41)=fread(fid,15,'short'); % EXTRA  Not used. All set to zero by default 
#b(42)=fread(fid,1,'short'); % NINT  Number of integer per section 
#b(43)=fread(fid,1,'short'); % NREAL  Number of reals per section 
#b(44:50)=fread(fid,7,'long'); % EXTRA2  Not used. All set to zero by default 
#b(51)=fread(fid,1,'short'); % IDTYPE  0=mono, 1=tilt, 2=tilts, 3=lina, 4=lins 
#b(52:56)=fread(fid,5,'short'); % LENS/ND1/ND2/VD1/VD2
#b(57:62)=fread(fid,6,'float'); % TILTANGLES Used to rotate model to match new rotated image 
#b(63:65)=fread(fid,3,'float'); % XORIGIN/YORIGIN/ZORIGIN Origin of image 
#b(66:69)=fread(fid,4,'char'); % CMAP Contains 'MAP'  
#b(70:73)=fread(fid,4,'char'); % STAMP
#b(74)=fread(fid,1,'float'); % RMS
#b(75)=fread(fid,1,'long'); % Number of labels being used
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"""

import math
import sys
#from pylab import *
import os
import struct
from numpy import reshape
#from scipy import *
#from matplotlib import *
#import matplotlib.pyplot as plt

def readMRCfile(fname):
  if not os.path.isfile(fname):
     print('can''t open file')
     exit(1)
  inputf = fname
  infile = open(inputf).read()
#  print('wahaha')
  start, stop = 0, struct.calcsize('iiii')
  nx, ny, nz, type = struct.unpack('iiii', infile[start:stop])
  b= struct.unpack('iiiiiiiiiiffffffiiifffhhihhhhhhhhhhhhhhhhhhiiiiiiihhhhhhfffffffffccccccccfi', infile[0:224])
  start, stop = 224, struct.calcsize('c')*800 + 224
  format = '800c'
  c=struct.unpack(format, infile[start:stop])
  totalNum = nx*ny*nz
  if type== 1:
     format = str(totalNum)+'i'
     start, stop = 1024, struct.calcsize('i')*nx*ny*nz+1024
     a=struct.unpack(format, infile[start:stop])
  if type== 2:
     format = str(totalNum)+'f'
     start, stop = 1024, struct.calcsize('f')*nx*ny*nz+1024
     a=struct.unpack(format, infile[start:stop])
  a = reshape(a, (nx,ny,nz))
  if nz == 1:
    a = reshape(a, (nx, ny))
  return a,b,c
