import os
import math
import struct
from numpy import reshape

# Write MRC files as produced by missing wedge code. Can possibly be used elsewhere but not tested.
# Francis Wang

def stringify(val):
    if (type(val) == str):
        return val
    else:
        return chr(val)

def writeMRCfile(a, b, c, fname, type):
    try:
        mrcFile = open(fname, "w")
    except IOError:
        print("Can't open file")
        exit(1)
    start, stop = 0, struct.calcsize('iiii')
    dims = a.shape
    ndims = len(dims)
    if ndims > 3:
        print "Too many dimensions"
        exit(1)
    nx = dims[0]
    ny = dims[1]
    newb = (dims[0], dims[1]) + b[4:]
    if ndims == 3:
        nz = dims[2]
        totalNum = nx * ny * nz
    else:
        totalNum = nx * ny
        nz = 1
    if type == "float":
        format2=str(totalNum) + 'f'
        bthree = 2
    elif type == "short":
        format2=str(totalNum) + 'i'
        bthree = 1
    newb = (nx, ny, nz, bthree) + b[4:65] + tuple([stringify(x) for x in b[65:73]]) + b[73:75]
    bstring = struct.pack('iiiiiiiiiiffffffiiifffhhihhhhhhhhhhhhhhhhhhiiiiiiihhhhhhfffffffffccccccccfi', *newb)
    start, stop = 224, struct.calcsize('c')*800 + 224
    format = '800c'
    if ndims == 2:
      a=reshape(a, nx*ny)
    if ndims == 3:
      a=reshape(a, nx*ny*nz)
    cstring = struct.pack(format, *c)
    astring = struct.pack(format2, *a)
    mrcFile.write(bstring)
    mrcFile.write(cstring)
    mrcFile.write(astring)
    mrcFile.close()
